//Demo programm for boards LPC-E2214 andLPC-E2294.
//Includes uart echo and LCD write 
void Initialize(void);
void feed(void);

void IRQ_Routine (void)   __attribute__ ((interrupt("IRQ")));
void FIQ_Routine (void)   __attribute__ ((interrupt("FIQ")));
void SWI_Routine (void)   __attribute__ ((interrupt("SWI")));
void UNDEF_Routine (void) __attribute__ ((interrupt("UNDEF")));

#include "lpc21xx.h"
//#include "config.h" /* Clock config */
#include "uart.h"
#include "lcd.h"
#define BAUD 9600
#define VREF  33/10  

#define PLOCK 0x400

int main(void) 
{
	unsigned int val, chan;
	unsigned int ch,ch2,state;

	Initialize();
	PINSEL0=0;
	PINSEL1 = 0;
	
	LCDInit();                    //LCD Initialization
	LCDSendCommand(DISP_ON);      //LCD on
	LCDSendCommand(CLR_DISP);     //LCD clear
	LCDSendCommand(DD_RAM_ADDR);  //LCD set first row
	

	LCDSendTxt("Hello,World");

	uart0Init(UART_BAUD(BAUD), UART_8N1, UART_FIFO_8);
	state=PINSEL0;
	uart1Init(UART_BAUD(BAUD), UART_8N1, UART_FIFO_8);
	
	uart1Puts("\r\nHello (uart1Puts)\r\n");
	ch=65;
	/**** LCD INITIALIZATION ****/

	while(1) {
		//UART0 test
		state=PINSEL0;
		/*ch=uart0Getch();
		if (ch>0)
			uart0Putch(ch);
		*/
		//UART1 test
		ch2=uart1GetchW();
		if (ch2>0)
			uart1Putch(ch2);
		//else uart1Putch(0x55);
	} // while
	
	return 0; /* never reached */
}


void Initialize(void)  {
	
 
	// 				Setting the Phased Lock Loop (PLL)
	//               ----------------------------------
	//
	// Olimex LPC-P2106 has a 14.7456 mhz crystal
	
   
	// Setting Multiplier and Divider values
  	PLLCFG=0x23;
  	feed();  
	// Enabling the PLL */	
	PLLCON=0x1;
	feed();
  
	// Wait for the PLL to lock to set frequency
	while(!(PLLSTAT & PLOCK)) ;
  
	// Connect the PLL as the clock source
	PLLCON=0x3;
	feed();
  
	// Enabling MAM and setting number of clocks used for Flash memory fetch (4 cclks in this case)
	//MAMCR=0x2;
	//MAMTIM=0x4;
  
	// Setting peripheral Clock (pclk) to System Clock (cclk)/4
	VPBDIV=0x0;
}


void feed(void)
{
  PLLFEED=0xAA;
  PLLFEED=0x55;
}

/*  Stubs for various interrupts (may be replaced later)  */
/*  ----------------------------------------------------  */

void IRQ_Routine (void) {
	while (1) ;	
}

void FIQ_Routine (void)  {
	while (1) ;	
}


void SWI_Routine (void)  {
	while (1) ;	
}


void UNDEF_Routine (void) {
	while (1) ;	
}
